"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetDispositionCodesFromEvaluation = exports.DispositionCodeMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function DispositionCodeMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.DispositionCodeMSSql = DispositionCodeMSSql;
function GetDispositionCodesFromEvaluation(vcc, userId, campaigns, searchType) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('SearchType', sql.VarChar(50), searchType)
        .execute('GetDispositionCodesFromEvaluation')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        recordset.map(function (dc) {
            if (dc.dispositionTreePath !== null) {
                var array = dc.dispositionTreePath.split('/').filter(function (r) { return r !== null && r !== ''; });
                dc.description = array[0] ? array[0] : null;
                dc.description2 = array[1] ? array[1] : null;
                dc.description3 = array[2] ? array[2] : null;
                dc.description4 = array[3] ? array[3] : null;
                dc.description5 = array[4] ? array[4] : null;
            }
        });
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetDispositionCodesFromEvaluation = GetDispositionCodesFromEvaluation;
