"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveEvaluationPlanAbilityStatusTask = exports.GetEvaluationPlanCognitiveInteractionTask = exports.GetEvaluationPlanAbilityGenericQueryTask = exports.GetEvaluationPlanTask = exports.DeleteEvaluationPlan = exports.SaveInteractionEvaluationPlanSample = exports.SaveAuditorEvPlanResult = exports.SaveEvaluationPlanCompleted = exports.DeleteAuditorEvaluationPlanByInteraction = exports.DeleteAuditorEvaluationPlan = exports.GetInteractionsEvaluationPlanWithoutFilters = exports.GetInteractionsEvaluationPlan = exports.GetEvaluationPlanInteractionByTypeAndId = exports.GetAuditorsEvaluationPlan = exports.GetEvaluationPlan = exports.SaveAuditorEvaluationPlan = exports.SaveEvaluationPlan = exports.BulkInteractionEvaluationPlan = exports.GetEvaluationPlansAgent = exports.GetEvaluationPlansAuditor = exports.GetEvaluationPlansSummary = exports.GetEvaluationPlansByStatus = exports.GetEvaluationPlanByInteractionId = exports.GetEvaluationPlanByProcessId = exports.GetEvaluationPlanByName = exports.GetEvaluationPlans = exports.EvaluationPlanMSSql = void 0;
var moment = require("moment");
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function EvaluationPlanMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.EvaluationPlanMSSql = EvaluationPlanMSSql;
function GetEvaluationPlans(instance, search_criteria, search_expression, disabled) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('Disabled', sql.Bit(), disabled)
        .execute('GetEvaluationPlans')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlans = GetEvaluationPlans;
function GetEvaluationPlanByName(vcc, description) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByName] Searching if exists evaluation plan: ' + description + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Description', sql.VarChar(50), description)
        .execute('GetEvaluationPlanByName')
        .then(function (recordsets) {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByName] Evaluation plan: ' + description + ' for VCC ' + vcc + ' exists.');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByName] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByName = GetEvaluationPlanByName;
function GetEvaluationPlanByProcessId(vcc, processId) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] Searching if exists evaluation plan with ProcessId: ' + processId + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('instance', sql.VarChar(50), vcc)
        .input('ProcessId', sql.VarChar(50), processId)
        .execute('GetEvaluationPlanByProcessId')
        .then(function (recordsets) {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] Evaluation plan processId: ' + processId + ' for VCC ' + vcc + ' exists.');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByProcessId = GetEvaluationPlanByProcessId;
function GetEvaluationPlanByInteractionId(vcc, interactionId) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] Searching if exists evaluation plan with InteractionId: ' + interactionId + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetEvaluationPlanByInteractionId')
        .then(function (recordsets) {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] Evaluation plan interactionId: ' + interactionId + ' for VCC ' + vcc + ' exists.');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByInteractionId = GetEvaluationPlanByInteractionId;
function GetEvaluationPlansByStatus(instance, status, disabled) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('Status', sql.Numeric(2), status)
        .input('Disabled', sql.Bit(), disabled)
        .execute('GetEvaluationPlansByStatus')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansByStatus = GetEvaluationPlansByStatus;
function GetEvaluationPlansSummary(instance, isAdmin, idAgent, idAuditor, campaigns, limitDate, evaluationFormats, modalities, completed) {
    var request = new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), instance)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit, completed);
    if (!isAdmin) {
        if (idAuditor != null)
            request.input('IdAuditor', sql.VarChar(sql.MAX), idAuditor);
        if (idAgent != null)
            request.input('IdAgent', sql.VarChar(sql.MAX), idAgent);
    }
    return request.execute('GetEvaluationPlansSummary')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Requesting error \'' + err.procName + '\': ' : 'Error on: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[evaluation-plan.mssql::GetEvaluationPlansMaster] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansSummary = GetEvaluationPlansSummary;
function GetEvaluationPlansAuditor(instance, userId, campaigns, limitDate, evaluationPlans, evaluationFormats, modalities, completed, userFuntion) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(sql.MAX), userId)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit(), completed)
        .input('UserFunction', sql.VarChar(50), userFuntion)
        .execute('GetEvaluationPlansAuditor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansAuditor = GetEvaluationPlansAuditor;
function GetEvaluationPlansAgent(instance, idAgent, campaigns, limitDate, evaluationFormats, modalities, completed) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAgent', sql.VarChar(sql.MAX), idAgent)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit, completed)
        .execute('GetEvaluationPlansAgent')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansAgent = GetEvaluationPlansAgent;
function BulkInteractionEvaluationPlan(vcc, evaluationPlan) {
    var table = SetInteractionEvaluationPlanTemporaryTable(vcc, evaluationPlan);
    return BulkInteractionEvaluationPlanTransaction(vcc, table);
}
exports.BulkInteractionEvaluationPlan = BulkInteractionEvaluationPlan;
function SetInteractionEvaluationPlanTemporaryTable(vcc, evaluationPlan) {
    var table = new sql.Table('#InteractionEvaluationPlanTemp');
    table.create = true;
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('IdEvaluationPlan', sql.VarChar(50), { nullable: true });
    table.columns.add('IdAgent', sql.VarChar(sql.MAX), { nullable: true });
    table.columns.add('AgentName', sql.VarChar(sql.MAX), { nullable: true });
    table.columns.add('IdCampaign', sql.VarChar(sql.MAX), { nullable: true });
    table.columns.add('IdInteraction', sql.VarChar(250), { nullable: true });
    table.columns.add('InteractionSection', sql.Int, { nullable: true });
    table.columns.add('InteractionPart', sql.Int, { nullable: true });
    table.columns.add('InteractionFolder', sql.VarChar(50), { nullable: true });
    table.columns.add('InteractionType', sql.VarChar(50), { nullable: true });
    table.columns.add('TotalMessages', sql.Int, { nullable: true });
    table.columns.add('InteractionDateStart', sql.DateTime, { nullable: true });
    table.columns.add('InteractionDateEnd', sql.DateTime, { nullable: true });
    table.columns.add('InteractionDuration', sql.Int, { nullable: true });
    table.columns.add('InteractionOrigin', sql.VarChar(50), { nullable: true });
    table.columns.add('InteractionManagementResult', sql.VarChar(sql.MAX), { nullable: true });
    table.columns.add('RelativePath', sql.VarChar(500), { nullable: true });
    table.columns.add('FileName', sql.VarChar(200), { nullable: true });
    table.columns.add('InteractionContactId', sql.VarChar(50), { nullable: true });
    table.columns.add('InteractionFormat', sql.VarChar(50), { nullable: true });
    table.columns.add('CreatedByUserId', sql.VarChar(50), { nullable: true });
    logger.info('[EvaluationPlanMSSql::SetInteractionEvaluationPlanTemporaryTable] Records to temporary table InteractionEvaluationPlanTemp: ' + evaluationPlan.channelInteractions.length);
    evaluationPlan.channelInteractions.map(function (i) {
        if (i.ID)
            i.id = i.ID;
        if (i.Direction)
            i.Type = i.Direction;
        if (i.ID && i.Direction) {
            i.Part = 0;
            i.Section = 0;
            i.Channel = 'CALL';
        }
        var managementResult = null;
        if (i.Description) {
            managementResult = '/';
            if (i.Category1)
                managementResult += i.Category1 + '/';
            if (i.Category2)
                managementResult += i.Category2 + '/';
            if (i.Category3)
                managementResult += i.Category3 + '/';
            managementResult += i.Description;
            managementResult = managementResult.split('//').join('/');
        }
        else {
            managementResult = i.dispositionTreePath || null;
        }
        table.rows.add(vcc, evaluationPlan.id, i.Agent ? i.Agent : i.firstTakedAgent || null, i.AgentName ? i.AgentName.trim().replace('  ', ' ') : null, i.Campaign ? i.Campaign : i.campaign || null, i.InteractionId ? i.InteractionId : i.id || null, (i.Section || i.Section === 0) ? i.Section : null, (i.Part || i.Part === 0) ? i.Part : null, i.folder ? i.folder : null, i.Channel ? i.Channel : i.channel || null, i.totalMessages ? i.totalMessages : null, i.StartDate ? moment.utc(i.StartDate).toDate() : moment.utc(i.startDate).toDate() || null, i.EndDate ? moment.utc(i.EndDate).toDate() : moment.utc(i.endDate).toDate() || null, i.DurationTime ? i.DurationTime : i.durationTime || null, i.Type ? (i.Type === 'E' ? 'IN' : 'OUT') : i.initiative || null, managementResult, i.RelativePath ? i.RelativePath : null, i.FileName ? i.FileName : null, i.Number ? i.Number : i.contactName || null, i.Format ? i.Format : i.format || null, evaluationPlan.createdByUserId);
    });
    return table;
}
function BulkInteractionEvaluationPlanTransaction(vcc, temporaryTable) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('[EvaluationPlanMSSql::BulkInteractionEvaluationPlanTransaction] Creating transaction');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(temporaryTable)
            .then(function (rowCount) {
            logger.info('[EvaluationPlanMSSql::BulkInteractionEvaluationPlanTransaction] Inserted ' + rowCount + ' records to temporary Table');
            return true;
        })
            .catch(function (err) {
            logger.error('[EvaluationPlanMSSql::BulkInteractionEvaluationPlanTransaction] Error on bulk: ' + err.message);
            throw err;
        });
    })
        .then(function (result) {
        return request
            .execute('BulkInteractionEvaluationPlan')
            .then(function (recordsets) {
            logger.info('[EvaluationPlanMSSql::BulkInteractionEvaluationPlanTransaction] Succed Execution');
            var results = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
            var promiseArray = [];
            promiseArray.push(Promise.resolve(results && results.length > 0 ? results[0] : null));
            promiseArray.push(transaction.commit());
            return Promise.all(promiseArray);
        })
            .catch(function (err) {
            logger.error('[EvaluationPlanMSSql::BulkInteractionEvaluationPlanTransaction] Error on: ' + err.message);
            return Promise.reject(err);
        });
    })
        .then(function (result) {
        return Promise.resolve(true);
    })
        .catch(function (err) {
        logger.error('[EvaluationPlanMSSql::BulkInteractionEvaluationPlanTransaction] Parsing error: ' + err.message);
        transaction.rollback();
        return Promise.reject(err);
    });
}
function SaveEvaluationPlan(instance, id, modality, dateFin, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, idEvaluationFormat, transcriptionLanguage, environmentId, description, enabled, filterByContent, filterByContentPercentage, evaluatePercentage, processAndEvaluate, filterByContentQueryName, filterByContentQuery, evaluationStarted, processId, status, evaluation_mode) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), id)
        .input('Modality', sql.VarChar(50), modality)
        .input('DateFin', sql.DateTime, dateFin)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('TranscriptionLanguage', sql.VarChar(25), transcriptionLanguage)
        .input('EnvironmentId', sql.VarChar(100), environmentId)
        .input('Description', sql.VarChar(200), description)
        .input('Enabled', sql.Bit(), enabled)
        .input('FilterByContent', sql.Bit(), filterByContent)
        .input('FilterByContentPercentage', sql.Numeric(3), filterByContentPercentage)
        .input('EvaluatePercentage', sql.Numeric(3), evaluatePercentage)
        .input('ProcessAndEvaluate', sql.Bit(), processAndEvaluate)
        .input('FilterByContentQueryName', sql.VarChar(50), filterByContentQueryName)
        .input('FilterByContentQuery', sql.VarChar(1000), filterByContentQuery)
        .input('EvaluationStarted', sql.Bit(), evaluationStarted)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Status', sql.Numeric(2), status)
        .input('Evaluation_Mode', sql.VarChar(10), evaluation_mode)
        .execute('SaveEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::SaveEvaluationPlan] Success request');
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error \'' + err.procName + '\': ' : 'Error on request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::SaveEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationPlan = SaveEvaluationPlan;
function SaveAuditorEvaluationPlan(instance, idEvaluationPlan, idAuditor, idInteraction, interactionType, interactionDateStart, interactionDateEnd, interactionDuration, idAgent, idCampaign, dispositionCode, origin, format, contactId, userId) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('IdAuditor', sql.VarChar(50), idAuditor)
        .input('IdInteraction', sql.VarChar(250), idInteraction)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('InteractionDate', sql.DateTime, interactionDateStart)
        .input('InteractionDateEnd', sql.DateTime, interactionDateEnd)
        .input('InteractionDuration', sql.Numeric(8), interactionDuration)
        .input('IdAgent', sql.VarChar(50), idAgent)
        .input('idCampaign', sql.VarChar(50), idCampaign)
        .input('InteractionDispositionCode', sql.VarChar(50), dispositionCode)
        .input('InteractionOrigin', sql.VarChar(50), origin)
        .input('InteractionFormat', sql.VarChar(50), format)
        .input('ContactId', sql.VarChar(50), contactId)
        .input('LastModifiedByUserId', sql.VarChar(50), userId)
        .execute('SaveAuditorEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::SaveAuditorEvaluationPlan] Success request');
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error \'' + err.procName + '\': ' : 'Error on request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::SaveAuditorEvaluationPlan] ' + errorMsg + '|' + idInteraction);
        return Promise.reject(err);
    });
}
exports.SaveAuditorEvaluationPlan = SaveAuditorEvaluationPlan;
function GetEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationPlan)
        .execute('GetEvaluationPlan')
        .then(function (recordsets) {
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Received result from SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Results from SP: ' + recordsets.length);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlan = GetEvaluationPlan;
function GetAuditorsEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('idEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('GetAuditorsEvaluationPlan')
        .then(function (recordsets) {
        logger.info('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] Received result from SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAuditorsEvaluationPlan = GetAuditorsEvaluationPlan;
function GetEvaluationPlanInteractionByTypeAndId(vcc, evaluationPlanId, interactionType, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetEvaluationPlanInteractionByTypeAndId')
        .then(function (recordsets) {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanInteractionByTypeAndId] EvaluationPlan::VCC => ' + evaluationPlanId + '::' + vcc);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var interactionEvaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(interactionEvaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByName] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanInteractionByTypeAndId = GetEvaluationPlanInteractionByTypeAndId;
function GetInteractionsEvaluationPlan(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('GetInteractionsEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        console.log(err);
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractionsEvaluationPlan = GetInteractionsEvaluationPlan;
function GetInteractionsEvaluationPlanWithoutFilters(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('idEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('GetInteractionsEvaluationPlanWithoutFilters')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractionsEvaluationPlanWithoutFilters = GetInteractionsEvaluationPlanWithoutFilters;
function DeleteAuditorEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('Eliminando asignaciones del plan de ev. ' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('DeleteAuditorEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAuditorEvaluationPlan = DeleteAuditorEvaluationPlan;
function DeleteAuditorEvaluationPlanByInteraction(vcc, idEvaluationPlan, idInteraction, interactionType, isDraft) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('IdInteraction', sql.VarChar(250), idInteraction)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('IsDraft', sql.Bit(), isDraft)
        .execute('DeleteAuditorEvaluationPlanByInteraction')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAuditorEvaluationPlanByInteraction = DeleteAuditorEvaluationPlanByInteraction;
function SaveEvaluationPlanCompleted(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('SaveEvaluationPlanCompleted')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationPlanCompleted = SaveEvaluationPlanCompleted;
function SaveAuditorEvPlanResult(instance, idEvaluationPlan, idAuditor, idInteraction, interactionType, idAgent, score) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('idAuditor', sql.VarChar(50), idAuditor)
        .input('idInteraction', sql.VarChar(50), idInteraction)
        .input('interactionType', sql.VarChar(50), interactionType)
        .input('idAgent', sql.VarChar(50), idAgent)
        .input('score', sql.Numeric(5, 2), score)
        .execute('SaveAuditorEvPlanResult')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAuditorEvPlanResult = SaveAuditorEvPlanResult;
function SaveInteractionEvaluationPlanSample(vcc, evaluationPlanId, evaluatePercentage) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('EvaluatePercentage', sql.Decimal(18, 2), evaluatePercentage)
        .execute('SaveInteractionEvaluationPlanSample')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveInteractionEvaluationPlanSample = SaveInteractionEvaluationPlanSample;
function DeleteEvaluationPlan(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('DeleteEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteEvaluationPlan = DeleteEvaluationPlan;
function TransactionBulkEvaluationPlanQuery(tableIdathaInteractionsResultTemp, BulkInteractionQuery, tempTableName) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('[EvaluationPlanMSSql::TransactionBulkEvaluationPlanFilteredInteractions] getting result after begin transaction instruction');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(tableIdathaInteractionsResultTemp)
            .then(function (rowCount) {
            logger.info('[EvaluationPlanMSSql::TransactionBulkEvaluationPlanFilteredInteractions] getting', rowCount, 'affected rows after performing bulk insert operation into temporary table:', tempTableName);
            return true;
        }).catch(function (err) {
            var errorMessage = typeof err === 'string' ? err : (err.message || err.description);
            logger.error('[EvaluationPlanMSSql::TransactionBulkEvaluationPlanFilteredInteractions] getting error:', errorMessage, 'after bulk insert operation into temporary table:', tempTableName);
            return Promise.resolve(false);
        });
    });
}
function TransactionBulkEvaluationPlanAbility(tableIdathaQueryResultTemp, BulkInteractionQuery, tempTableName) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('[EvaluationPlanMSSql::TransactionBulkEvaluationPlanAbility] getting result after begin transaction instruction');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(tableIdathaQueryResultTemp)
            .then(function (rowCount) {
            logger.info('[EvaluationPlanMSSql::TransactionBulkBulkEvaluationPlanAbility] getting', rowCount, 'affected rows after performing bulk insert operation into temporary table:', tempTableName);
            return true;
        }).catch(function (err) {
            var errorMessage = typeof err === 'string' ? err : (err.message || err.description);
            logger.error('[EvaluationPlanMSSql::TransactionBulkBulkEvaluationPlanAbility] getting error:', errorMessage, 'after bulk insert operation into temporary table:', tempTableName);
            return Promise.resolve(false);
        });
    });
}
function TransactionBulkEvaluationPlanAbilityCognitive(tableCognitiveNluResultTemp, BulkInteractionQuery, tempTableName) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('[EvaluationPlanMSSql::TransactionBulkEvaluationPlanAbilityCognitive] getting result after begin transaction instruction');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(tableCognitiveNluResultTemp)
            .then(function (rowCount) {
            logger.info('[EvaluationPlanMSSql::TransactionBulkEvaluationPlanAbilityCognitive] getting', rowCount, 'affected rows after performing bulk insert operation into temporary table:', tempTableName);
            return true;
        }).catch(function (err) {
            var errorMessage = typeof err === 'string' ? err : (err.message || err.description);
            logger.error('[EvaluationPlanMSSql::TransactionBulkEvaluationPlanAbilityCognitive] getting error:', errorMessage, 'after bulk insert operation into temporary table:', tempTableName);
            return Promise.resolve(false);
        });
    });
}
function GetEvaluationPlanTask(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationPlan)
        .execute('GetEvaluationPlanTask')
        .then(function (recordsets) {
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Received result from SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Results from SP: ' + recordsets.length);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanTask = GetEvaluationPlanTask;
function GetEvaluationPlanAbilityGenericQueryTask(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilityGenericQueryTask')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilityGenericQueryTask = GetEvaluationPlanAbilityGenericQueryTask;
function GetEvaluationPlanCognitiveInteractionTask(vcc, evaluationPlanId) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlanCognitiveInteractionTask] getting vcc:', vcc, 'evaluationPlanId:', evaluationPlanId);
    var genericResult = {};
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanCognitiveInteractionTask')
        .then(function (recordsets) {
        var callCognitiveInteractions = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var asyncCognitiveInteractions = (recordsets && recordsets.length > 1 ? recordsets[1] : null);
        callCognitiveInteractions = callCognitiveInteractions ? callCognitiveInteractions : [];
        asyncCognitiveInteractions = asyncCognitiveInteractions ? asyncCognitiveInteractions : [];
        genericResult.status = true;
        genericResult.description = 'OK';
        genericResult.data = callCognitiveInteractions.concat(asyncCognitiveInteractions);
        return Promise.resolve(genericResult);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanCognitiveInteractionTask = GetEvaluationPlanCognitiveInteractionTask;
function SaveEvaluationPlanAbilityStatusTask(instance, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), instance)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('SaveEvaluationPlanAbilityStatusTask')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationPlanAbilityStatusTask = SaveEvaluationPlanAbilityStatusTask;
