"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveEvaluationCustomFieldResult = exports.ReportAuditsByAgent = exports.SaveInteractionEvaluationPlanResult = exports.DeleteEvaluationResultDraftBackup = exports.RestoreEvaluationResultDraftBackup = exports.SaveEvaluationResultDraftBackup = exports.DeleteEvaluationResults = exports.SaveEvaluationResult = exports.SaveEvaluationStatus = exports.GetEvaluations = exports.GetEvaluationsOfInteraction = exports.GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan = exports.GetEvaluationResultsFromAuditorEvaluationPlan = exports.GetEvaluationResults = exports.EvaluationMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function EvaluationMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.EvaluationMSSql = EvaluationMSSql;
function GetEvaluationResults(vcc, evaluationPlanId, interactionId, auditorId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .execute('GetEvaluationResults')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationResults = GetEvaluationResults;
function GetEvaluationResultsFromAuditorEvaluationPlan(instance, evaluationPlanId, interactionId, interactionType, auditorId, agentId) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .input('AgentId', sql.VarChar(50), agentId)
        .execute('GetEvaluationResultsFromAuditorEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationResultsFromAuditorEvaluationPlan = GetEvaluationResultsFromAuditorEvaluationPlan;
function GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan(vcc, evaluationPlanId, interactionId, auditorId, agentId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .input('AgentId', sql.VarChar(50), agentId)
        .execute('GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan = GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan;
function GetEvaluationsOfInteraction(instance, interaction, interactionType, evaluationDateFrom, evaluationDateTo) {
    logger.info('[EvaluationMSSql::GetEvaluationsOfInteraction] Calling GetEvaluationsOfInteraction SP');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdInteraction', sql.VarChar(250), interaction)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('EvaluationDateFrom', sql.VarChar(50), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(50), evaluationDateTo)
        .execute('GetEvaluationsOfInteraction')
        .then(function (recordsets) {
        logger.info('[EvaluationMSSql::GetEvaluationsOfInteraction] Received resulto from GetEvaluationsOfInteraction SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationsOfInteraction = GetEvaluationsOfInteraction;
function GetEvaluations(instance, auditorIds, agentIds, campaignIds, evaluationPlanIds, evaluationDateFrom, evaluationDateTo, evaluationHourFrom, evaluationHourTo, interactionMinDuration, interactionMaxDuration, interactionOrigins, interactionResults, evaluationTypes, interactionTags, interactionFormats, interacionCoached, interactionIds) {
    if (interactionIds === void 0) { interactionIds = ''; }
    logger.info('[EvaluationMSSql::GetEvaluations] Calling GetEvaluations SP');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAuditor', sql.VarChar(sql.MAX), auditorIds)
        .input('IdAgent', sql.VarChar(sql.MAX), agentIds)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaignIds)
        .input('IdEvaluationPlan', sql.VarChar(sql.MAX), evaluationPlanIds)
        .input('EvaluationDateFrom', sql.VarChar(50), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(50), evaluationDateTo)
        .input('EvaluationHourFrom', sql.VarChar(50), evaluationHourFrom)
        .input('EvaluationHourTo', sql.VarChar(50), evaluationHourTo)
        .input('InteractionMinDuration', sql.Int, interactionMinDuration)
        .input('InteractionMaxDuration', sql.Int, interactionMaxDuration)
        .input('InteractionOrigins', sql.VarChar(50), interactionOrigins)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('EvaluationTypes', sql.VarChar(sql.MAX), evaluationTypes)
        .input('InteractionTags', sql.VarChar(sql.MAX), interactionTags)
        .input('InteractionFormats', sql.VarChar(sql.MAX), interactionFormats)
        .input('InteractionCoached', sql.VarChar(50), interacionCoached)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .execute('GetEvaluations')
        .then(function (result) {
        logger.info('[EvaluationMSSql::GetEvaluations] Received result from GetEvaluations SP');
        var recordset = (result && result.length > 0 ? result[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationMSSql::GetEvaluations] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluations = GetEvaluations;
function SaveEvaluationStatus(vcc, evaluationPlanId, interactionId, auditorId, status, multiple, currentUser) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .input('Status', sql.Bit(), status)
        .input('Multiple', sql.Bit(), multiple)
        .input('LastModifiedByUserId', sql.VarChar(50), currentUser)
        .execute('SaveEvaluationStatus')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationStatus = SaveEvaluationStatus;
function SaveEvaluationResult(instance, id, idCampaign, IdInteraction, IdAgent, IdEvaluationFormat, minQualificationAcceptable, IdGroup, IdSubGroup, IdAbility, Qualification, ownScore, inheritedScore, IdEvaluator, EvaluationDate, MaxAbilityScore, abilityInnerScore, IdEvaluationPlan, Comment, NotApplies, ScoreDescription, CampaignDescription, AgentDescription, InteractionDateini, InteractionDatefin, interactionAddress, InteractionType, abilityOrder, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, conditional) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('Id', sql.VarChar(250), id)
        .input('IdCampaign', sql.VarChar(100), idCampaign)
        .input('IdInteraction', sql.VarChar(250), IdInteraction)
        .input('IdAgent', sql.VarChar(100), IdAgent)
        .input('IdEvaluationFormat', sql.VarChar(100), IdEvaluationFormat)
        .input('MinQualificationAcceptable', sql.Numeric(5, 2), minQualificationAcceptable)
        .input('IdGroup', sql.VarChar(100), IdGroup)
        .input('IdSubGroup', sql.VarChar(100), IdSubGroup)
        .input('IdAbility', sql.VarChar(100), IdAbility)
        .input('Qualification', sql.Numeric(5, 2), Qualification)
        .input('OwnScore', sql.Numeric(5, 2), ownScore)
        .input('InheritedScore', sql.Numeric(5, 2), inheritedScore)
        .input('IdEvaluator', sql.VarChar(100), IdEvaluator)
        .input('EvaluationDate', sql.DateTime, EvaluationDate)
        .input('MaxAbilityScore', sql.Int(), MaxAbilityScore)
        .input('AbilityInnerScore', sql.Int(), abilityInnerScore)
        .input('IdEvaluationPlan', sql.VarChar(50), IdEvaluationPlan)
        .input('Comment', sql.VarChar(1000), Comment)
        .input('NotApplies', sql.Bit, NotApplies)
        .input('ScoreDescription', sql.VarChar(50), ScoreDescription)
        .input('CampaignDescription', sql.VarChar(100), CampaignDescription)
        .input('AgentDescription', sql.VarChar(100), AgentDescription)
        .input('InteractionDateini', sql.DateTime, InteractionDateini)
        .input('InteractionDatefin', sql.DateTime, InteractionDatefin)
        .input('InteractionAddress', sql.VarChar(50), interactionAddress)
        .input('InteractionType', sql.VarChar(100), InteractionType)
        .input('AbilityOrder', sql.VarChar(100), abilityOrder)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('Conditional', sql.VarChar(50), conditional)
        .execute('SaveEvaluationResult')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationResult = SaveEvaluationResult;
function DeleteEvaluationResults(instance, interactionId, interactionType, evaluationPlanId, agentId, auditorId) {
    logger.info('[evaluation.mssql.ts] - DeleteEvaluationResults | Start');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdInteraction', sql.VarChar(250), interactionId)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('IdEvaluationPlan', sql.VarChar(50), evaluationPlanId)
        .input('IdAgent', sql.VarChar(50), agentId)
        .input('IdAuditor', sql.VarChar(50), auditorId)
        .execute('DeleteEvaluationResults')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteEvaluationResults = DeleteEvaluationResults;
function SaveEvaluationResultDraftBackup(vcc, evaluationPlanId, interactionType, interactionId, auditorId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .execute('SaveEvaluationResultDraftBackup')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationResultDraftBackup = SaveEvaluationResultDraftBackup;
function RestoreEvaluationResultDraftBackup(vcc, evaluationPlanId, interactionId, auditorId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .execute('RestoreEvaluationResultDraftBackup')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.RestoreEvaluationResultDraftBackup = RestoreEvaluationResultDraftBackup;
function DeleteEvaluationResultDraftBackup(vcc, evaluationPlanId, interactionId, auditorId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .execute('DeleteEvaluationResultDraftBackup')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteEvaluationResultDraftBackup = DeleteEvaluationResultDraftBackup;
function SaveInteractionEvaluationPlanResult(vcc, evaluationPlanId, auditorId, interactionId, interactionType, summarizedScore, summarizedAtomaticScore, summarizedManualScore, isDraft) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('IdEvaluationPlan', sql.VarChar(50), evaluationPlanId)
        .input('IdAuditor', sql.VarChar(50), auditorId)
        .input('IdInteraction', sql.VarChar(250), interactionId)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('Score', sql.Numeric(5, 2), summarizedScore)
        .input('AutomaticScore', sql.Numeric(5, 2), summarizedAtomaticScore)
        .input('ManualScore', sql.Numeric(5, 2), summarizedManualScore)
        .input('IsDraft', sql.Bit(), isDraft)
        .execute('SaveInteractionEvaluationPlanResult')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveInteractionEvaluationPlanResult = SaveInteractionEvaluationPlanResult;
function ReportAuditsByAgent(instance, idEvaluationFormat, idsCampanias, idAgente, fechaDesde, fechaHasta, idAuditor, planAuditoria) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('IdsCampanias', sql.VarChar(1000), idsCampanias)
        .input('IdAgente', sql.VarChar(50), idAgente)
        .input('FechaDesde', sql.Date(), fechaDesde)
        .input('FechaHasta', sql.Date(), fechaHasta)
        .input('IdAuditor', sql.VarChar(50), idAuditor)
        .input('PlanAuditoria', sql.VarChar(50), planAuditoria)
        .execute('ReportAuditsByAgent')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.ReportAuditsByAgent = ReportAuditsByAgent;
function SaveEvaluationCustomFieldResult(vcc, evaluationPlanId, interactionId, auditorId, agentId, customFieldId, result, createdByUserId, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .input('AgentId', sql.VarChar(50), agentId)
        .input('CustomFieldId', sql.VarChar(100), customFieldId)
        .input('Result', sql.VarChar(150), result)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveEvaluationCustomFieldResult')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationCustomFieldResult = SaveEvaluationCustomFieldResult;
