"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SortObjectArrayByShuffle = exports.SortObjectArrayByValue = exports.GetUniqueFromObjectArray = exports.GetUniqueFromArray = exports.GetCompareItemsFromObjectArray = void 0;
function GetCompareItemsFromObjectArray(oldArr, newArr, keyPropertyOA, keyPropertyNA) {
    if (!oldArr)
        oldArr = [];
    if (!newArr)
        newArr = [];
    var newItems = [];
    var oldItems = [];
    var removedItems = [];
    oldArr.map(function (oa) {
        if (!newArr.find(function (na) { return na[keyPropertyNA] === oa[keyPropertyOA]; }))
            removedItems.push(oa);
        else
            oldItems.push(oa);
    });
    newArr.map(function (na) {
        if (!oldArr.find(function (oa) { return oa[keyPropertyOA] === na[keyPropertyNA]; }))
            newItems.push(na);
    });
    return {
        new: newItems,
        old: oldItems,
        removed: removedItems
    };
}
exports.GetCompareItemsFromObjectArray = GetCompareItemsFromObjectArray;
function GetUniqueFromArray(arr) {
    var reducedArray = arr.reduce(function (unique, item) {
        return unique.includes(item) ? unique : __spreadArrays(unique, [item]);
    }, []);
    return reducedArray;
}
exports.GetUniqueFromArray = GetUniqueFromArray;
function GetUniqueFromObjectArray(arr, value) {
    var unique = arr
        .map(function (e) { return e[value]; })
        .map(function (e, i, final) { return final.indexOf(e) === i && i; })
        .filter(function (e) { return arr[e]; }).map(function (e) { return arr[e]; });
    return unique;
}
exports.GetUniqueFromObjectArray = GetUniqueFromObjectArray;
function SortObjectArrayByValue(arr, property, sortType) {
    var sortedObjectArray = [];
    switch (sortType) {
        case 'A':
            sortedObjectArray = arr.sort(function (a, b) { return (a[property] < b[property] ? -1 : 1); });
            break;
        case 'D':
            sortedObjectArray = arr.sort(function (a, b) { return (a[property] > b[property] ? -1 : 1); });
            break;
    }
    return sortedObjectArray;
}
exports.SortObjectArrayByValue = SortObjectArrayByValue;
function SortObjectArrayByShuffle(arr) {
    var _a;
    var currentIndex = arr.length, randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex--;
        _a = [
            arr[randomIndex], arr[currentIndex]
        ], arr[currentIndex] = _a[0], arr[randomIndex] = _a[1];
    }
    return arr;
}
exports.SortObjectArrayByShuffle = SortObjectArrayByShuffle;
