"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
var log4js = require("log4js");
var logger = log4js.getLogger('ServerScripts');
var auth_service_1 = require("./auth.service");
var batch_service_1 = require("./batch.service");
var batch_schedule_service_1 = require("./batch-schedule.service");
var custom_field_service_1 = require("./custom-field.service");
var diarization_service_1 = require("./diarization.service");
var dictionary_service_1 = require("./dictionary.service");
var entity_service_1 = require("./entity.service");
var home_service_1 = require("./home.service");
var profile_image_service_1 = require("./profile-image.service");
var report_service_1 = require("./report.service");
var role_service_1 = require("./role.service");
var user_service_1 = require("./user.service");
var api_user_service_1 = require("./api-user.service");
var client_service_1 = require("./client.service");
var process_service_1 = require("./process.service");
var idatha_service_1 = require("./idatha.service");
var feeling_service_1 = require("./feeling.service");
var category_service_1 = require("./category.service");
var neuro_linguistic_programming_service_1 = require("./neuro-linguistic-programming.service");
var template_service_1 = require("./template.service");
var generic_template_service_1 = require("./generic-template.service");
var generic_query_service_1 = require("./generic-query.service");
var nlu_service_1 = require("./nlu.service");
var intent_service_1 = require("./intent.service");
var utterance_service_1 = require("./utterance.service");
var train_service_1 = require("./train.service");
var environment_service_1 = require("./environment.service");
var allegro_service_1 = require("./allegro.service");
var audio_service_1 = require("./audio.service");
var exception_service_1 = require("./exception.service");
var country_service_1 = require("./country.service");
var tag_service_1 = require("./tag.service");
var study_service_1 = require("./study.service");
var word_blacklist_service_1 = require("./word-blacklist.service");
var vcc_service_1 = require("./vcc.service");
var linguistic_service_1 = require("./linguistic.service");
var platform_service_1 = require("./platform.service");
var account_service_1 = require("./account.service");
var average_group_rating_service_1 = require("./average-group-rating.service");
var interaction_service_1 = require("./interaction.service");
var attentionlevel_service_1 = require("./attentionlevel.service");
var agents_service_1 = require("./agents.service");
var evaluation_format_service_1 = require("./evaluation-format.service");
var top_best_agents_service_1 = require("./top-best-agents.service");
var evaluation_plan_service_1 = require("./evaluation-plan.service");
var evaluation_service_1 = require("./evaluation.service");
var group_service_1 = require("./group.service");
var auditor_service_1 = require("./auditor.service");
var subgroup_service_1 = require("./subgroup.service");
var average_group_rating_norm_service_1 = require("./average-group-rating-norm.service");
var top_worst_agents_service_1 = require("./top-worst-agents.service");
var campain_service_1 = require("./campain.service");
var ability_service_1 = require("./ability.service");
var interaction_type_service_1 = require("./interaction-type.service");
var campaign_fulfillment_service_1 = require("./campaign-fulfillment.service");
var workgroup_service_1 = require("./workgroup.service");
var disposition_code_service_1 = require("./disposition-code.service");
var interactions_by_type_service_1 = require("./interactions-by-type.service");
var io_service_1 = require("./io.service");
function init(app) {
    logger.info('Incializando servicios');
    auth_service_1.AuthService(app);
    batch_service_1.BatchService(app);
    batch_schedule_service_1.BatchScheduleService(app);
    custom_field_service_1.CustomFieldService(app);
    diarization_service_1.DiarizationService(app);
    dictionary_service_1.DictionaryService(app);
    entity_service_1.EntityService(app);
    home_service_1.HomeService(app);
    profile_image_service_1.ProfileImageService(app);
    report_service_1.ReportService(app);
    role_service_1.RoleService(app);
    user_service_1.UserService(app);
    api_user_service_1.ApiUserService(app);
    client_service_1.ClientService(app);
    country_service_1.CountryService(app);
    process_service_1.ProcessService(app);
    idatha_service_1.IdathaService(app);
    feeling_service_1.FeelingService(app);
    category_service_1.CategoryService(app);
    neuro_linguistic_programming_service_1.NeuroLinguisticProgrammingService(app);
    template_service_1.TemplateService(app);
    generic_template_service_1.GenericTemplateService(app);
    generic_query_service_1.GenericQueryService(app);
    nlu_service_1.NLUService(app);
    intent_service_1.IntentService(app);
    utterance_service_1.UtteranceService(app);
    train_service_1.TrainService(app);
    environment_service_1.EnvironmentService(app);
    allegro_service_1.AllegroService(app);
    audio_service_1.AudioService(app);
    exception_service_1.ExceptionService(app);
    tag_service_1.TagService(app);
    study_service_1.StudyService(app);
    word_blacklist_service_1.WordBlacklistService(app);
    tag_service_1.TagService(app);
    vcc_service_1.VCCService(app);
    linguistic_service_1.LinguisticService(app);
    platform_service_1.PlatformService(app);
    account_service_1.AccountService(app);
    campaign_fulfillment_service_1.CampaignFulfillmentService(app);
    average_group_rating_service_1.AverageGroupRatingService(app);
    average_group_rating_norm_service_1.AverageGroupRatingNormService(app);
    top_best_agents_service_1.TopBestAgentsService(app);
    top_worst_agents_service_1.TopWorstAgentsService(app);
    interactions_by_type_service_1.InteractionsByTypeService(app);
    ability_service_1.AbilityService(app);
    subgroup_service_1.SubgroupService(app);
    group_service_1.GroupService(app);
    evaluation_format_service_1.EvaluationFormatService(app);
    campain_service_1.CampainService(app);
    agents_service_1.AgentsService(app);
    workgroup_service_1.WorkGroupService(app);
    attentionlevel_service_1.AttentionLevelService(app);
    interaction_service_1.InteractionService(app);
    evaluation_plan_service_1.EvaluationPlanService(app);
    interaction_type_service_1.InteractionTypeService(app);
    evaluation_service_1.EvaluationService(app);
    auditor_service_1.AuditorService(app);
    disposition_code_service_1.DispositionCodeService(app);
    io_service_1.IOService(app);
}
exports.init = init;
